PROGRAM P2;


USES
        PortSig;


CONST
        PortADR = 763;         (* COM2-Base 2F8H + 3 *)

VAR
        sig     : PortSIGNAL;
        count1,
        count2  : CARDINAL;

BEGIN
  count1 := 0;
  sig := SignalInit( PortADR, f_P2);

  Write('P2: Waiting for Signal... ');
  REPEAT
    INC( count1);
    count2 := 0;
    REPEAT
      IF SignalReceived( sig) THEN BEGIN
        INC( count2);
        Write('Signal received.');
        ClearOwnSignal( sig);
        Write('P2: Waiting for Signal... ');

        IF count2 < 5 THEN BEGIN
          SendSignalTo( sig, f_P1);
          WriteLn('  Signal sent to P1.');
        END;
      END;

    UNTIL count2 = 5;
    WriteLn('-- inner Loop ended.');
  UNTIL count1 = 2;

  SignalDone( sig);
END (* P2 *).
